import { Injectable, ɵɵdefineInjectable, EventEmitter, Component, ViewChild, Input, Output, NgModule, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';
import html2canvas from 'html2canvas';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-capture.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// declare var html2canvas: any;
// import * as html2canvas_ from 'html2canvas';
// const html2canvas = html2canvas_;
class NgxCaptureService {
    constructor() { }
    /**
     * @param {?} screen
     * @param {?=} fullCapture
     * @param {?=} cropDimensions
     * @return {?}
     */
    getImage(screen, fullCapture, cropDimensions) {
        /** @type {?} */
        let options = {
            logging: false
        };
        if (!fullCapture && cropDimensions.width > 10 && cropDimensions.height > 10) {
            options = Object.assign({}, options, cropDimensions);
        }
        else if (!fullCapture) {
            return;
        }
        return html2canvas(screen, options).then((/**
         * @param {?} canv
         * @return {?}
         */
        canv => {
            /** @type {?} */
            const img = canv.toDataURL('image/png');
            return Promise.resolve(img);
        }), (/**
         * @param {?} err
         * @return {?}
         */
        err => {
            throw new Error(err);
        })).catch((/**
         * @param {?} res
         * @return {?}
         */
        res => {
            throw new Error(res);
        }));
    }
    // TODO
    /**
     * @private
     * @param {?} img
     * @return {?}
     */
    downloadImage(img) {
        // this.canvas.nativeElement.src = img;
        // this.downloadLink.nativeElement.href = img;
        // this.downloadLink.nativeElement.download = 'test.png';
        // this.downloadLink.nativeElement.click();
    }
}
NgxCaptureService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
NgxCaptureService.ctorParameters = () => [];
/** @nocollapse */ NgxCaptureService.ngInjectableDef = ɵɵdefineInjectable({ factory: function NgxCaptureService_Factory() { return new NgxCaptureService(); }, token: NgxCaptureService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-capture.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxCaptureComponent {
    /**
     * @param {?} captureService
     */
    constructor(captureService) {
        this.captureService = captureService;
        this.resultImage = new EventEmitter();
        this.isDrawing = false;
        this.cropDimensions = {
            x: 0,
            y: 0,
            width: 0,
            height: 0
        };
        this.mouse = {
            x: 0,
            y: 0,
            startX: 0,
            startY: 0
        };
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        // if (!this.captureZone) {
        //   console.warn('"captureZone" is not set');
        //   return;
        // }
        setTimeout((/**
         * @return {?}
         */
        () => {
            this.rect = this.rectangle.nativeElement;
            this.captureZone = this.overlay.nativeElement;
            this.captureZone.onmousedown = (/**
             * @param {?} e
             * @return {?}
             */
            (e) => this.startCapture(e));
            this.captureZone.onmousemove = (/**
             * @param {?} e
             * @return {?}
             */
            (e) => this.drawRect(e));
            this.captureZone.onmouseup = (/**
             * @return {?}
             */
            () => this.endCapture());
        }), 2000);
    }
    /**
     * @private
     * @return {?}
     */
    setRectangle() {
        this.rect.style.left = this.cropDimensions.x + 'px';
        this.rect.style.top = this.cropDimensions.y + 'px';
        this.rect.style.width = this.cropDimensions.width + 'px';
        this.rect.style.height = this.cropDimensions.height + 'px';
    }
    /**
     * @private
     * @param {?} e
     * @return {?}
     */
    startCapture(e) {
        this.setMousePosition(e);
        this.isDrawing = true;
        this.mouse.startX = this.mouse.x;
        this.mouse.startY = this.mouse.y;
        this.cropDimensions = {
            x: this.mouse.x,
            y: this.mouse.y,
            width: 0,
            height: 0,
        };
        this.setRectangle();
        this.captureZone.style.cursor = 'crosshair';
    }
    /**
     * @private
     * @param {?} e
     * @return {?}
     */
    drawRect(e) {
        if (this.isDrawing) {
            this.setMousePosition(e);
            this.cropDimensions = {
                x: (this.mouse.x - this.mouse.startX < 0) ? this.mouse.x : this.mouse.startX,
                y: (this.mouse.y - this.mouse.startY < 0) ? this.mouse.y : this.mouse.startY,
                width: Math.abs(this.mouse.x - this.mouse.startX),
                height: Math.abs(this.mouse.y - this.mouse.startY),
            };
            this.setRectangle();
        }
    }
    /**
     * @private
     * @param {?} e
     * @return {?}
     */
    setMousePosition(e) {
        // tslint:disable-next-line: deprecation
        /** @type {?} */
        const ev = e || window.event;
        if (ev.pageX) { // Moz
            this.mouse.x = ev.pageX + window.pageXOffset;
            this.mouse.y = ev.pageY + window.pageYOffset;
        }
        else if (ev.clientX) { // IE
            this.mouse.x = ev.clientX + document.body.scrollLeft;
            this.mouse.y = ev.clientY + document.body.scrollTop;
        }
    }
    /**
     * @private
     * @return {?}
     */
    endCapture() {
        this.captureZone.style.cursor = 'default';
        this.isDrawing = false;
        this.captureService
            .getImage(this.target, false, this.cropDimensions)
            .then((/**
         * @param {?} img
         * @return {?}
         */
        img => {
            this.resultImage.emit(img);
        }));
        this.cropDimensions = {
            x: 0,
            y: 0,
            width: 0,
            height: 0
        };
        this.setRectangle();
    }
}
NgxCaptureComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngx-capture',
                template: `
  <ng-content></ng-content>
  <div class="overlay" #over>
    <div class="rectangle" #rect></div>
  </div>
  `,
                styles: [".overlay{top:0;left:0;position:absolute;background-color:rgba(204,204,204,.1);width:100vw;height:100vh}.rectangle{border:1px solid red;position:absolute}"]
            }] }
];
/** @nocollapse */
NgxCaptureComponent.ctorParameters = () => [
    { type: NgxCaptureService }
];
NgxCaptureComponent.propDecorators = {
    rectangle: [{ type: ViewChild, args: ['rect', { static: true },] }],
    overlay: [{ type: ViewChild, args: ['over', { static: true },] }],
    target: [{ type: Input }],
    resultImage: [{ type: Output }]
};
if (false) {
    /** @type {?} */
    NgxCaptureComponent.prototype.rectangle;
    /** @type {?} */
    NgxCaptureComponent.prototype.overlay;
    /** @type {?} */
    NgxCaptureComponent.prototype.target;
    /** @type {?} */
    NgxCaptureComponent.prototype.resultImage;
    /** @type {?} */
    NgxCaptureComponent.prototype.rect;
    /** @type {?} */
    NgxCaptureComponent.prototype.captureZone;
    /** @type {?} */
    NgxCaptureComponent.prototype.isDrawing;
    /** @type {?} */
    NgxCaptureComponent.prototype.cropDimensions;
    /** @type {?} */
    NgxCaptureComponent.prototype.mouse;
    /**
     * @type {?}
     * @private
     */
    NgxCaptureComponent.prototype.captureService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-capture.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxCaptureModule {
}
NgxCaptureModule.decorators = [
    { type: NgModule, args: [{
                declarations: [NgxCaptureComponent],
                imports: [],
                exports: [NgxCaptureComponent],
                schemas: [CUSTOM_ELEMENTS_SCHEMA]
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-capture.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxCaptureComponent, NgxCaptureModule, NgxCaptureService };
//# sourceMappingURL=ngx-capture.js.map
