import { __assign } from 'tslib';
import { Injectable, ɵɵdefineInjectable, EventEmitter, Component, ViewChild, Input, Output, NgModule, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';
import html2canvas from 'html2canvas';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-capture.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// declare var html2canvas: any;
// import * as html2canvas_ from 'html2canvas';
// const html2canvas = html2canvas_;
var NgxCaptureService = /** @class */ (function () {
    function NgxCaptureService() {
    }
    /**
     * @param {?} screen
     * @param {?=} fullCapture
     * @param {?=} cropDimensions
     * @return {?}
     */
    NgxCaptureService.prototype.getImage = /**
     * @param {?} screen
     * @param {?=} fullCapture
     * @param {?=} cropDimensions
     * @return {?}
     */
    function (screen, fullCapture, cropDimensions) {
        /** @type {?} */
        var options = {
            logging: false
        };
        if (!fullCapture && cropDimensions.width > 10 && cropDimensions.height > 10) {
            options = __assign({}, options, cropDimensions);
        }
        else if (!fullCapture) {
            return;
        }
        return html2canvas(screen, options).then((/**
         * @param {?} canv
         * @return {?}
         */
        function (canv) {
            /** @type {?} */
            var img = canv.toDataURL('image/png');
            return Promise.resolve(img);
        }), (/**
         * @param {?} err
         * @return {?}
         */
        function (err) {
            throw new Error(err);
        })).catch((/**
         * @param {?} res
         * @return {?}
         */
        function (res) {
            throw new Error(res);
        }));
    };
    // TODO
    // TODO
    /**
     * @private
     * @param {?} img
     * @return {?}
     */
    NgxCaptureService.prototype.downloadImage = 
    // TODO
    /**
     * @private
     * @param {?} img
     * @return {?}
     */
    function (img) {
        // this.canvas.nativeElement.src = img;
        // this.downloadLink.nativeElement.href = img;
        // this.downloadLink.nativeElement.download = 'test.png';
        // this.downloadLink.nativeElement.click();
    };
    NgxCaptureService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    NgxCaptureService.ctorParameters = function () { return []; };
    /** @nocollapse */ NgxCaptureService.ngInjectableDef = ɵɵdefineInjectable({ factory: function NgxCaptureService_Factory() { return new NgxCaptureService(); }, token: NgxCaptureService, providedIn: "root" });
    return NgxCaptureService;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-capture.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxCaptureComponent = /** @class */ (function () {
    function NgxCaptureComponent(captureService) {
        this.captureService = captureService;
        this.resultImage = new EventEmitter();
        this.isDrawing = false;
        this.cropDimensions = {
            x: 0,
            y: 0,
            width: 0,
            height: 0
        };
        this.mouse = {
            x: 0,
            y: 0,
            startX: 0,
            startY: 0
        };
    }
    /**
     * @return {?}
     */
    NgxCaptureComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        // if (!this.captureZone) {
        //   console.warn('"captureZone" is not set');
        //   return;
        // }
        var _this = this;
        setTimeout((/**
         * @return {?}
         */
        function () {
            _this.rect = _this.rectangle.nativeElement;
            _this.captureZone = _this.overlay.nativeElement;
            _this.captureZone.onmousedown = (/**
             * @param {?} e
             * @return {?}
             */
            function (e) { return _this.startCapture(e); });
            _this.captureZone.onmousemove = (/**
             * @param {?} e
             * @return {?}
             */
            function (e) { return _this.drawRect(e); });
            _this.captureZone.onmouseup = (/**
             * @return {?}
             */
            function () { return _this.endCapture(); });
        }), 2000);
    };
    /**
     * @private
     * @return {?}
     */
    NgxCaptureComponent.prototype.setRectangle = /**
     * @private
     * @return {?}
     */
    function () {
        this.rect.style.left = this.cropDimensions.x + 'px';
        this.rect.style.top = this.cropDimensions.y + 'px';
        this.rect.style.width = this.cropDimensions.width + 'px';
        this.rect.style.height = this.cropDimensions.height + 'px';
    };
    /**
     * @private
     * @param {?} e
     * @return {?}
     */
    NgxCaptureComponent.prototype.startCapture = /**
     * @private
     * @param {?} e
     * @return {?}
     */
    function (e) {
        this.setMousePosition(e);
        this.isDrawing = true;
        this.mouse.startX = this.mouse.x;
        this.mouse.startY = this.mouse.y;
        this.cropDimensions = {
            x: this.mouse.x,
            y: this.mouse.y,
            width: 0,
            height: 0,
        };
        this.setRectangle();
        this.captureZone.style.cursor = 'crosshair';
    };
    /**
     * @private
     * @param {?} e
     * @return {?}
     */
    NgxCaptureComponent.prototype.drawRect = /**
     * @private
     * @param {?} e
     * @return {?}
     */
    function (e) {
        if (this.isDrawing) {
            this.setMousePosition(e);
            this.cropDimensions = {
                x: (this.mouse.x - this.mouse.startX < 0) ? this.mouse.x : this.mouse.startX,
                y: (this.mouse.y - this.mouse.startY < 0) ? this.mouse.y : this.mouse.startY,
                width: Math.abs(this.mouse.x - this.mouse.startX),
                height: Math.abs(this.mouse.y - this.mouse.startY),
            };
            this.setRectangle();
        }
    };
    /**
     * @private
     * @param {?} e
     * @return {?}
     */
    NgxCaptureComponent.prototype.setMousePosition = /**
     * @private
     * @param {?} e
     * @return {?}
     */
    function (e) {
        // tslint:disable-next-line: deprecation
        /** @type {?} */
        var ev = e || window.event;
        if (ev.pageX) { // Moz
            this.mouse.x = ev.pageX + window.pageXOffset;
            this.mouse.y = ev.pageY + window.pageYOffset;
        }
        else if (ev.clientX) { // IE
            this.mouse.x = ev.clientX + document.body.scrollLeft;
            this.mouse.y = ev.clientY + document.body.scrollTop;
        }
    };
    /**
     * @private
     * @return {?}
     */
    NgxCaptureComponent.prototype.endCapture = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        this.captureZone.style.cursor = 'default';
        this.isDrawing = false;
        this.captureService
            .getImage(this.target, false, this.cropDimensions)
            .then((/**
         * @param {?} img
         * @return {?}
         */
        function (img) {
            _this.resultImage.emit(img);
        }));
        this.cropDimensions = {
            x: 0,
            y: 0,
            width: 0,
            height: 0
        };
        this.setRectangle();
    };
    NgxCaptureComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngx-capture',
                    template: "\n  <ng-content></ng-content>\n  <div class=\"overlay\" #over>\n    <div class=\"rectangle\" #rect></div>\n  </div>\n  ",
                    styles: [".overlay{top:0;left:0;position:absolute;background-color:rgba(204,204,204,.1);width:100vw;height:100vh}.rectangle{border:1px solid red;position:absolute}"]
                }] }
    ];
    /** @nocollapse */
    NgxCaptureComponent.ctorParameters = function () { return [
        { type: NgxCaptureService }
    ]; };
    NgxCaptureComponent.propDecorators = {
        rectangle: [{ type: ViewChild, args: ['rect', { static: true },] }],
        overlay: [{ type: ViewChild, args: ['over', { static: true },] }],
        target: [{ type: Input }],
        resultImage: [{ type: Output }]
    };
    return NgxCaptureComponent;
}());
if (false) {
    /** @type {?} */
    NgxCaptureComponent.prototype.rectangle;
    /** @type {?} */
    NgxCaptureComponent.prototype.overlay;
    /** @type {?} */
    NgxCaptureComponent.prototype.target;
    /** @type {?} */
    NgxCaptureComponent.prototype.resultImage;
    /** @type {?} */
    NgxCaptureComponent.prototype.rect;
    /** @type {?} */
    NgxCaptureComponent.prototype.captureZone;
    /** @type {?} */
    NgxCaptureComponent.prototype.isDrawing;
    /** @type {?} */
    NgxCaptureComponent.prototype.cropDimensions;
    /** @type {?} */
    NgxCaptureComponent.prototype.mouse;
    /**
     * @type {?}
     * @private
     */
    NgxCaptureComponent.prototype.captureService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-capture.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxCaptureModule = /** @class */ (function () {
    function NgxCaptureModule() {
    }
    NgxCaptureModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [NgxCaptureComponent],
                    imports: [],
                    exports: [NgxCaptureComponent],
                    schemas: [CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];
    return NgxCaptureModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-capture.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxCaptureComponent, NgxCaptureModule, NgxCaptureService };
//# sourceMappingURL=ngx-capture.js.map
